(function ($) {
    'use strict';
    $(document).ready(function () {

        let savedTerminalId = undefined;

        const terminalMatcher = (params, data) => {
            const originalMatcher = $.fn.select2.defaults.defaults.matcher;
            const result = originalMatcher(params, data);
            if (
                result &&
                data.children &&
                result.children &&
                data.children.length
            ) {
                if (
                    data.children.length !== result.children.length &&
                    data.text.toLowerCase().includes(params.term.toLowerCase())
                ) {
                    result.children = data.children;
                }
                return result;
            }
            return null;
        }

        const recurse = (parent) => {

            if (parent.nodeName === 'SELECT' && parent.className === 'woo_lithuaniapost_lpexpress_terminal_id') {
                $(parent).select2({
                    width: 'resolve',
                    matcher(params, data) {
                        return terminalMatcher(params, data);
                    },
                });
                return;
            }
            if (parent.childNodes) {
                [...parent.childNodes].forEach(recurse);
            }
        };

        // select the target node
        var target = $('.cart-collaterals, #order_review');
        let terminalIdElem = $('.woo_lithuaniapost_lpexpress_terminal_id');
        if (terminalIdElem.length > 0) {
            $(terminalIdElem).select2({
                width: 'resolve',
                matcher(params, data) {
                    return terminalMatcher(params, data);
                },
            });
        }

        if (target) {
            // create an observer instance
            var observer = new MutationObserver(function (mutations) {
                //loop through the detected mutations(added controls)
                mutations.forEach(function (mutation) {
                    for (const node of mutation.addedNodes) {
                        recurse(node);
                    }
                });
            });
            let obsConfig = {
                childList: true,
                characterData: true,
                attributes: true,
                subtree: true
            };
            target.each(function () {
                observer.observe(this, obsConfig);
            });

            // later, you can stop observing
            //observer.disconnect();

            $(target).on('change', terminalIdElem, function () {
                const selectedOption = $(this).find(":selected");
                const terminalId = selectedOption.attr('value') ?? selectedOption.val();
                if (terminalId && terminalId !== savedTerminalId && !isNaN(terminalId)) {
                    $.ajax({
                        type: "POST",
                        dataType: "json",
                        url: woo_lithuaniapost.ajax_url,
                        data: {
                            action: "save_selected_lpexpress_terminal",
                            terminal: this.value,
                            terminal_id: terminalId
                        }, success: function () {
                            savedTerminalId = terminalId;
                        }
                    });
                }

            });
        }
    });
})(jQuery);